;  ATtini84
; 
;v1.1
;--------------------------------------------------------------------
;
;			 ________	
;	   VCC	1|		|14  GND
;    8 MHz	2|		|13  PA0-
;    8 MHz	3|		|12
;    RESET	4|		|11
; PB2-	5|		|10
;			6|		|9
;		    7|		|8
;			 --------
;
;==============   ==================================

		.DEVICE		ATtiny84
		.nolist
		.include	"tn84def.inc"
		.list

		.def		mod0		= r0		;
		.def		mod1		= r1		;

		.def		MCUCRISC0	= r10		;   
		.def		MCUCRISC1	= r11		;   
		.def		GIMSKINT0	= r12		;   INT0
		.def		GIMSKINT1	= r13		;   INT0
		.def		temp		= r16		; temp
		.def		zero		= r17		; "0"
		.def		lc			= r19		;  / 
		.def		TC1_x		= r20		;    TC1
		.def		razr0		= r21		;    LB
		.def		razr1		= r22		;    HB

		.def		var20		= r26		;   
		.def		var21		= r27		;    35 .
		
		.def		var12		= r28		;  
		.def		var13		= r29		;   
		.def		var10		= r30		; 35000000/96 -> 0x059027
		.def		var11		= r31		; K1=35000000/96*N


;--------------------------------------------------------------------
;                 *****   *****
;--------------------------------------------------------------------
		.cseg						;   
		.org	0					;    
;==============   ==================================
		rjmp	RESET				; Reset Handler
		rjmp	EXTINT0				; IRQ0 Handler
		reti	;rjmp	PCINT0		; PCINT0 Handler
		reti	;rjmp	PCINT1		; PCINT1 Handler
		reti	;rjmp	WDT 		; Watchdog Interrupt Hand
		reti	;rjmp	TIM1_CAPT	; Timer1 Capture Handler
		reti	;rjmp	TIM1_COMPA	; Timer1 Compare A Handle
		reti	;rjmp	TIM1_COMPB	; Timer1 Compare B Handle
		rjmp	TIM1_OVF			; Timer1 Overflow Handler
		reti	;rjmp	TIM0_COMPA	; Timer0 Compare A Handle
		reti	;rjmp	TIM0_COMPB	; Timer0 Compare B Handle
		reti	;rjmp	TIM0_OVF	; Timer0 Overflow Handler
		reti	;rjmp	ANA_COMP	; Analog Comparator Handl
		reti	;rjmp	ADC			; ADC Conversion Handler
		reti	;rjmp	EE_RDY		; EEPROM Ready Handler
		reti	;rjmp	USI_STR		; USI STart Handler
		reti	;rjmp	USI_OVF		; USI Overflow Handler

;==============   =================================
RESET:
		ldi		temp,	low(RAMEND)
		out		SPL,	temp
		ldi		temp,	high(RAMEND)
		out		SPH,	temp

;==============  ===========================================
		clr		zero				; 0x00
		sbi		DDRA,	PA0			;  Pin13  
		cbi		PORTA,	PA0			;    "0"
		cbi		PORTB,	PB2			;    "0"
		mov		MCUCRISC0,zero		;   
		mov		GIMSKINT0,zero		;   INT0
		ldi		temp,	1<<ISC00	;
		mov		MCUCRISC1,temp		;   
		ldi		temp,	1<<INT0		;
		mov		GIMSKINT1,temp		;   INT0
		out		MCUCR,	MCUCRISC1	; INT0  
		out		GIMSK,	GIMSKINT1	;    Pin5
		ldi		TC1_x,	3<<CS10		; 
		out		TCCR1B,	TC1_x		;   T1  =64
		ldi		temp,	1<<ACD		;   
		out		ACSR,	temp		;   

;==============   ========================================
k_zam:	sbic	PINB,	PINB2		;   
		rjmp	k_zam				;  
		ser		temp				;
		out		GIFR,	temp		;   
		sei							;   

MAIN:
		rjmp	MAIN


;==============  INT0 ======================================
EXTINT0:
;--------------   --------------------------------
		brbs	SREG_T,	rising		;   T  -> rising
		sbi		PORTA,	PA0			;    "1"
		out		TCNT1H,	zero		; --------------------------------
		out		TCNT1L,	zero		;   T2
		rcall	delay				;   ""
		ldi		temp,	0x27		; --------------------------------
		mov		var10,	temp		;  
		ldi		temp,	0x90		;    
		mov		var11,	temp		;   
		ldi		temp,	0x05		; 
		mov		var12,	temp		; 35000000/96 --> "0x059027" 
		ldi		temp,	0x00		;
		mov		var13,	temp		; ________________________________
		set							;   T
		ser		temp				;
		out		GIFR,	temp		;   
		reti

;--------------   --------------------------------
rising:	
		cbi		PORTA,	PA0			;    "0"
		in		var20,	TCNT1L		;   
		in		var21,	TCNT1H		; T1   Y
		rcall	delay				;   ""
		cpi		var21,	0x0E		;  var21=0E (<400)
		brsh	notab				;   notab
		cpi		var21,	0x00		;  var21=00 (>5700)
		breq	notab				;   notab

;============== 32bit/16bit  ==================================
; Register Variables
;  Call:  var1[3:0] = dividend (0x00000000..0xffffffff)
;         var2[1:0] = divisor (0x0001..0x7fff)
;         mod[1:0]  = <don't care>
;         lc        = <don't care> (high register must be allocated)
;;  Result:var1[3:0] = var1[3:0] / var2[1:0]
;         var2[3:0] = <not changed>
;         mod[3:0]  = var1[3:0] % var2[1:0]
;         lc        = 0
;; Size  = 26 words
; Clock = 549..677 cycles (+ret)
; Stack = 0 bytes
;----------------------------------------------------------------------
div32x16:
		in		temp,	SREG		;  
		clr		mod0				; initialize variables
		clr		mod1				; mod = 0;
		ldi		lc,		32			; lc = 32;    /
		lsl		var10				; ---- calculating loop 
		rol		var11				; var1 = var1 << 1;
		rol		var12				;
		rol		var13				; /
		rol		mod0				; mod = mod << 1 + carry;
		rol		mod1				; /
		cp		mod0,	var20		; if (mod => var2) {
		cpc		mod1,	var21		;  mod -= var2; var1++;}
		brcs	PC+4				;
		inc		var10				;
		sub		mod0,	var20		;
		sbc		mod1,	var21		; /
		dec		lc					; if (--lc > 0)
		brne	PC-13				; continue loop;
		out		SREG,	temp		;  

;--------------      --------
;       .
;         (8),
;     
;   (8)     3 
;     (400/8=50) +1   
;   400      (2),   
;    .
;--------------	   -------------------------

		;lsl		var10				;   2
		;rol		var11				;   2
		;lsl		var10				;   2
		;rol		var11				;   2
		cbr		var10,	0			;  
		cbr		var10,	1			;  
		subi	var10,	0x64		;   100
		sbci	var11,	0x00		;
		ldi		temp,	low(tab*2)	;    
		add		var10,	temp		;   
		ldi		temp,	high(tab*2) ;    
		adc		var11,	temp		;   
		lpm							;    TCN1  r0
		mov		r1,		r0			;
		adiw	Z,		1			;
		lpm							;    TCN1  r0
		out		TCNT1H,	r0			;   TCN1
		out		TCNT1L,	r1			;
		ldi		temp,	1<<TOIE1	;  
		out		TIMSK1,	temp		;   T2
		clt							;   T
		ser		temp				;
		out		GIFR,	temp		;   
		reti						;   

;==============     =========================
notab:
		ser		temp				;
		out		GIFR,	temp		;   
		clt							;   T
		reti						;   

;==============   =========================================
delay:	
		in		temp,	SREG		;  
		ldi		razr0,	0xC5		;---------------------------------
		ldi		razr1,	0x07		;  Razr1, Razr0
		subi	razr0,	1			;   ~ 1c
		sbci	razr1,	0			;_________________________________
		brcc	PC-2				;
		out		SREG,	temp		;  
		ret

;==============  TIM1_OVF ==================================
TIM1_OVF:
		sbi		PORTA,	PA0			;    "1"
		out		TIMSK1,	zero		;    T2
		reti						;   

tab:
.dw 0xE9ED
.dw 0xEA61
.dw 0xEACC
.dw 0xEB32
.dw 0xEB99
.dw 0xEBF8
.dw 0xEC54
.dw 0xECB1
.dw 0xED06
.dw 0xED58
.dw 0xEDAC
.dw 0xEDF9
.dw 0xEE43
.dw 0xEE90
.dw 0xEED6
.dw 0xEF19
.dw 0xEF5E
.dw 0xEF9E
.dw 0xEFDC
.dw 0xF01C
.dw 0xF055
.dw 0xF092
.dw 0xF0C9
.dw 0xF0FE
.dw 0xF135
.dw 0xF168
.dw 0xF19C
.dw 0xF1CC
.dw 0xF1FB
.dw 0xF22B
.dw 0xF258
.dw 0xF286
.dw 0xF2B0
.dw 0xF2DC
.dw 0xF304
.dw 0xF32B
.dw 0xF355
.dw 0xF37A
.dw 0xF3A1
.dw 0xF3C5
.dw 0xF3EB
.dw 0xF40D
.dw 0xF431
.dw 0xF451
.dw 0xF474
.dw 0xF493
.dw 0xF4B5
.dw 0xF4D2
.dw 0xF4F2
.dw 0xF50F
.dw 0xF52D
.dw 0xF548
.dw 0xF566
.dw 0xF580
.dw 0xF59D
.dw 0xF5B6
.dw 0xF5D1
.dw 0xF5E9
.dw 0xF604
.dw 0xF61B
.dw 0xF635
.dw 0xF64C
.dw 0xF664
.dw 0xF679
.dw 0xF692
.dw 0xF6A9
.dw 0xF6BD
.dw 0xF6D4
.dw 0xF6E8
.dw 0xF6FD
.dw 0xF710
.dw 0xF726
.dw 0xF73A
.dw 0xF74D
.dw 0xF760
.dw 0xF775
.dw 0xF786
.dw 0xF799
.dw 0xF7AA
.dw 0xF7BC
.dw 0xF7CF
.dw 0xF7DF
.dw 0xF7F0
.dw 0xF802
.dw 0xF811
.dw 0xF822
.dw 0xF831
.dw 0xF842
.dw 0xF852
.dw 0xF860
.dw 0xF86F
.dw 0xF87F
.dw 0xF88E
.dw 0xF89C
.dw 0xF8AB
.dw 0xF8BA
.dw 0xF8C6
.dw 0xF8D5
.dw 0xF8E3
.dw 0xF8EF
.dw 0xF8FD
.dw 0xF90A
.dw 0xF918
.dw 0xF923
.dw 0xF930
.dw 0xF93D
.dw 0xF94A
.dw 0xF955
.dw 0xF961
.dw 0xF96E
.dw 0xF97A
.dw 0xF984
.dw 0xF990
.dw 0xF99C
.dw 0xF9A8
.dw 0xF9B1
.dw 0xF9BD
.dw 0xF9C8
.dw 0xF9D3
.dw 0xF9DD
.dw 0xF9E7
.dw 0xF9F1
.dw 0xF9FC
.dw 0xFA07
.dw 0xFA11
.dw 0xFA1A
.dw 0xFA24
.dw 0xFA2D
.dw 0xFA37
.dw 0xFA41
.dw 0xFA4B
.dw 0xFA53
.dw 0xFA5D
.dw 0xFA65
.dw 0xFA6F
.dw 0xFA78
.dw 0xFA81
.dw 0xFA8A
.dw 0xFA91
.dw 0xFA9A
.dw 0xFAA3
.dw 0xFAAB
.dw 0xFAB4
.dw 0xFABA
.dw 0xFAC3
.dw 0xFACB
.dw 0xFAD3
.dw 0xFADA
.dw 0xFAE2
.dw 0xFAEA
.dw 0xFAF1
.dw 0xFAF9
.dw 0xFAFF
.dw 0xFB07
.dw 0xFB0F
.dw 0xFB16
.dw 0xFB1E
.dw 0xFB24
.dw 0xFB2B
.dw 0xFB32
.dw 0xFB39
.dw 0xFB40
.dw 0xFB46
.dw 0xFB4D
.dw 0xFB54
.dw 0xFB5A
.dw 0xFB61
.dw 0xFB68
.dw 0xFB6E
.dw 0xFB73
.dw 0xFB7A
.dw 0xFB80
.dw 0xFB87
.dw 0xFB8D
.dw 0xFB94
.dw 0xFB99
.dw 0xFB9F
.dw 0xFBA5
.dw 0xFBAB
.dw 0xFBB1
.dw 0xFBB7
.dw 0xFBBC
.dw 0xFBC3
.dw 0xFBC8
.dw 0xFBCE
.dw 0xFBD3
.dw 0xFBD8
.dw 0xFBDE
.dw 0xFBE3
.dw 0xFBE9
.dw 0xFBEE
.dw 0xFBF4
.dw 0xFBF9
.dw 0xFBFF
.dw 0xFC03
.dw 0xFC09
.dw 0xFC0E
.dw 0xFC13
.dw 0xFC18
.dw 0xFC1D
.dw 0xFC23
.dw 0xFC26
.dw 0xFC2B
.dw 0xFC30
.dw 0xFC35
.dw 0xFC3A
.dw 0xFC3F
.dw 0xFC43
.dw 0xFC48
.dw 0xFC4C
.dw 0xFC52
.dw 0xFC56
.dw 0xFC5A
.dw 0xFC5F
.dw 0xFC63
.dw 0xFC69
.dw 0xFC6D
.dw 0xFC71
.dw 0xFC76
.dw 0xFC7A
.dw 0xFC7E
.dw 0xFC82
.dw 0xFC86
.dw 0xFC8B
.dw 0xFC90
.dw 0xFC94
.dw 0xFC98
.dw 0xFC9C
.dw 0xFCA0
.dw 0xFCA4
.dw 0xFCA8
.dw 0xFCAC
.dw 0xFCB0
.dw 0xFCB4
.dw 0xFCB8
.dw 0xFCBC
.dw 0xFCC0
.dw 0xFCC3
.dw 0xFCC7
.dw 0xFCCC
.dw 0xFCD0
.dw 0xFCD3
.dw 0xFCD7
.dw 0xFCDB
.dw 0xFCDE
.dw 0xFCE2
.dw 0xFCE6
.dw 0xFCE9
.dw 0xFCEC
.dw 0xFCF1
.dw 0xFCF5
.dw 0xFCF8
.dw 0xFCFB
.dw 0xFCFF
.dw 0xFD02
.dw 0xFD05
.dw 0xFD09
.dw 0xFD0D
.dw 0xFD10
.dw 0xFD13
.dw 0xFD16
.dw 0xFD1A
.dw 0xFD1E
.dw 0xFD21
.dw 0xFD24
.dw 0xFD27
.dw 0xFD2C
.dw 0xFD2F
.dw 0xFD32
.dw 0xFD35
.dw 0xFD38
.dw 0xFD3C
.dw 0xFD3F
.dw 0xFD43
.dw 0xFD45
.dw 0xFD48
.dw 0xFD4B
.dw 0xFD4F
.dw 0xFD52
.dw 0xFD55
.dw 0xFD57
.dw 0xFD5B
.dw 0xFD5E
.dw 0xFD61
.dw 0xFD65
.dw 0xFD67
.dw 0xFD6A
.dw 0xFD6C
.dw 0xFD70
.dw 0xFD73
.dw 0xFD76
.dw 0xFD79
.dw 0xFD7C
.dw 0xFD7E
.dw 0xFD81
.dw 0xFD84
.dw 0xFD87
.dw 0xFD89
.dw 0xFD8A
.dw 0xFD8D
.dw 0xFD8F
.dw 0xFD91
.dw 0xFD93
.dw 0xFD95
.dw 0xFD97
.dw 0xFD99
.dw 0xFD9C
.dw 0xFD9D
.dw 0xFD9F
.dw 0xFDA2
.dw 0xFDA3
.dw 0xFDA6
.dw 0xFDA7
.dw 0xFDA9
.dw 0xFDAC
.dw 0xFDAD
.dw 0xFDAF
.dw 0xFDB1
.dw 0xFDB2
.dw 0xFDB4
.dw 0xFDB6
.dw 0xFDB8
.dw 0xFDBA
.dw 0xFDBC
.dw 0xFDBE
.dw 0xFDC0
.dw 0xFDC1
.dw 0xFDC3
.dw 0xFDC5
.dw 0xFDC7
.dw 0xFDC8
.dw 0xFDCA
.dw 0xFDCC
.dw 0xFDCD
.dw 0xFDCF
.dw 0xFDD0
.dw 0xFDD2
.dw 0xFDD4
.dw 0xFDD5
.dw 0xFDD7
.dw 0xFDD9
.dw 0xFDDB
.dw 0xFDDC
.dw 0xFDDE
.dw 0xFDDF
.dw 0xFDE0
.dw 0xFDE2
.dw 0xFDE4
.dw 0xFDE6
.dw 0xFDE7
.dw 0xFDE8
.dw 0xFDEA
.dw 0xFDEB
.dw 0xFDED
.dw 0xFDEE
.dw 0xFDF0
.dw 0xFDF1
.dw 0xFDF3
.dw 0xFDF4
.dw 0xFDF6
.dw 0xFDF7
.dw 0xFDF9
.dw 0xFDFA
.dw 0xFDFC
.dw 0xFDFE
.dw 0xFDFE
.dw 0xFE00
.dw 0xFE01
.dw 0xFE03
.dw 0xFE04
.dw 0xFE05
.dw 0xFE06
.dw 0xFE09
.dw 0xFE09
.dw 0xFE0B
.dw 0xFE0C
.dw 0xFE0E
.dw 0xFE0F
.dw 0xFE10
.dw 0xFE11
.dw 0xFE12
.dw 0xFE14
.dw 0xFE15
.dw 0xFE16
.dw 0xFE17
.dw 0xFE19
.dw 0xFE1A
.dw 0xFE1B
.dw 0xFE1C
.dw 0xFE1E
.dw 0xFE1F
.dw 0xFE20
.dw 0xFE21
.dw 0xFE23
.dw 0xFE23
.dw 0xFE25
.dw 0xFE26
.dw 0xFE28
.dw 0xFE28
.dw 0xFE2A
.dw 0xFE2B
.dw 0xFE2C
.dw 0xFE2D
.dw 0xFE2E
.dw 0xFE30
.dw 0xFE31
.dw 0xFE32
.dw 0xFE33
.dw 0xFE34
.dw 0xFE35
.dw 0xFE36
.dw 0xFE37
.dw 0xFE38
.dw 0xFE3A
.dw 0xFE3A
.dw 0xFE3B
.dw 0xFE3C
.dw 0xFE3D
.dw 0xFE3F
.dw 0xFE40
.dw 0xFE41
.dw 0xFE41
.dw 0xFE43
.dw 0xFE44
.dw 0xFE44
.dw 0xFE46
.dw 0xFE47
.dw 0xFE48
.dw 0xFE49
.dw 0xFE49
.dw 0xFE4B
.dw 0xFE4C
.dw 0xFE4D
.dw 0xFE4E
.dw 0xFE4F
.dw 0xFE50
.dw 0xFE50
.dw 0xFE51
.dw 0xFE52
.dw 0xFE53
.dw 0xFE54
.dw 0xFE55
.dw 0xFE56
.dw 0xFE57
.dw 0xFE58
.dw 0xFE59
.dw 0xFE5A
.dw 0xFE5A
.dw 0xFE5B
.dw 0xFE5C
.dw 0xFE5D
.dw 0xFE5E
.dw 0xFE5F
.dw 0xFE60
.dw 0xFE61
.dw 0xFE62
.dw 0xFE62
.dw 0xFE63
.dw 0xFE65
.dw 0xFE66
.dw 0xFE66
.dw 0xFE67
.dw 0xFE68
.dw 0xFE69
.dw 0xFE69
.dw 0xFE6A
.dw 0xFE6B
.dw 0xFE6C
.dw 0xFE6D
.dw 0xFE6E
.dw 0xFE6F
.dw 0xFE70
.dw 0xFE71
.dw 0xFE72
.dw 0xFE72
.dw 0xFE73
.dw 0xFE74
.dw 0xFE75
.dw 0xFE75
.dw 0xFE77
.dw 0xFE77
.dw 0xFE78
.dw 0xFE79
.dw 0xFE79
.dw 0xFE7A
.dw 0xFE7B
.dw 0xFE7C
.dw 0xFE7D
.dw 0xFE7E
.dw 0xFE7E
.dw 0xFE7F
.dw 0xFE80
.dw 0xFE80
.dw 0xFE82
.dw 0xFE82
.dw 0xFE83
.dw 0xFE84
.dw 0xFE85
.dw 0xFE85
.dw 0xFE86
.dw 0xFE87
.dw 0xFE88
.dw 0xFE89
.dw 0xFE89
.dw 0xFE89
.dw 0xFE8A
.dw 0xFE8B
.dw 0xFE8C
.dw 0xFE8D
.dw 0xFE8D
.dw 0xFE8E
.dw 0xFE8F
.dw 0xFE90
.dw 0xFE90
.dw 0xFE91
.dw 0xFE92
.dw 0xFE92
.dw 0xFE93
.dw 0xFE94
.dw 0xFE94
.dw 0xFE95
.dw 0xFE96
.dw 0xFE97
.dw 0xFE98
.dw 0xFE98
.dw 0xFE98
.dw 0xFE99
.dw 0xFE9A
.dw 0xFE9B
.dw 0xFE9B
.dw 0xFE9D
.dw 0xFE9D
.dw 0xFE9D
.dw 0xFE9E
.dw 0xFE9F
.dw 0xFE9F
.dw 0xFEA0
.dw 0xFEA0
.dw 0xFEA1
.dw 0xFEA2
.dw 0xFEA3
.dw 0xFEA3
.dw 0xFEA4
.dw 0xFEA4
.dw 0xFEA5
.dw 0xFEA6
.dw 0xFEA7
.dw 0xFEA7
.dw 0xFEA7
.dw 0xFEA8
.dw 0xFEA9
.dw 0xFEAA
.dw 0xFEAA
.dw 0xFEAA
.dw 0xFEAB
.dw 0xFEAC
.dw 0xFEAD
.dw 0xFEAE
.dw 0xFEAE
.dw 0xFEAE
.dw 0xFEAF
.dw 0xFEB0
.dw 0xFEB0
.dw 0xFEB1
.dw 0xFEB2
.dw 0xFEB2
.dw 0xFEB2
.dw 0xFEB3
.dw 0xFEB4
.dw 0xFEB5
.dw 0xFEB5
.dw 0xFEB5
.dw 0xFEB6
.dw 0xFEB7
.dw 0xFEB7
.dw 0xFEB8
.dw 0xFEB9
.dw 0xFEB9
.dw 0xFEB9
.dw 0xFEBA
.dw 0xFEBB
.dw 0xFEBB
.dw 0xFEBC
.dw 0xFEBD
.dw 0xFEBD
.dw 0xFEBD
.dw 0xFEBE
.dw 0xFEBF
.dw 0xFEBF
.dw 0xFEBF
.dw 0xFEC0
.dw 0xFEC1
.dw 0xFEC1
.dw 0xFEC2
.dw 0xFEC3
.dw 0xFEC3
.dw 0xFEC3
.dw 0xFEC4
.dw 0xFEC4
.dw 0xFEC5
.dw 0xFEC6
.dw 0xFEC6
.dw 0xFEC7
.dw 0xFEC7
.dw 0xFEC7
.dw 0xFEC8
.dw 0xFEC9
.dw 0xFEC9
.dw 0xFEC9
.dw 0xFECA
.dw 0xFECA
.dw 0xFECB
.dw 0xFECC
.dw 0xFECC
.dw 0xFECD
.dw 0xFECD
.dw 0xFECD
.dw 0xFECE
.dw 0xFECF
.dw 0xFECF
.dw 0xFED0
.dw 0xFED0
.dw 0xFED0
.dw 0xFED1
.dw 0xFED1
.dw 0xFED2
.dw 0xFED3
.dw 0xFED3
.dw 0xFED3
.dw 0xFED4
.dw 0xFED4
.dw 0xFED5
.dw 0xFED5
.dw 0xFED6
.dw 0xFED6
.dw 0xFED6
.dw 0xFED7
.dw 0xFED8
.dw 0xFED8
.dw 0xFED9
.dw 0xFED9
.dw 0xFEDA
.dw 0xFEDA
.dw 0xFEDA
.dw 0xFEDB
.dw 0xFEDB
.dw 0xFEDC
.dw 0xFEDC
.dw 0xFEDC
.dw 0xFEDD
.dw 0xFEDD
.dw 0xFEDE
.dw 0xFEDE
.dw 0xFEDF
.dw 0xFEE0
.dw 0xFEE0
.dw 0xFEE0
.dw 0xFEE0
.dw 0xFEE1
.dw 0xFEE1
.dw 0xFEE2
.dw 0xFEE2
.dw 0xFEE2
